import i from "electron";
import { AbstractHub as h } from "duplex-message";
import { setConfig as l } from "duplex-message";
const p = "message-hub";
class a extends h {
  constructor(e, s) {
    if (super(e), e.type !== process.type)
      throw new TypeError(
        `[${s}]can only be used in electron ${e.type === "browser" ? "main" : "renderer"} process`
      );
    this._ipc = e.type === "browser" ? i.ipcMain : i.ipcRenderer, this._channelName = e.channelName || p, this.onMessage = this.onMessage.bind(this), this._ipc.on(this._channelName, this.onMessage);
  }
  sendMessage(e, s) {
    e.send(this._channelName, s);
  }
  async onMessage(e, s) {
    super.onMessage(e.sender, s);
  }
  destroy() {
    this.isDestroyed || (super.destroy(), this._ipc.off(this._channelName, this.onMessage), this._ipc = null);
  }
}
let t;
class o extends a {
  constructor(e) {
    super({ ...e, type: "browser" }, "MainMessageHub");
  }
  emit(e, s, ...r) {
    return super._emit(e, s, ...r);
  }
  on(e, s, r) {
    this._on(e, s, r);
  }
  off(e, s) {
    this._off(e, s);
  }
  /** shared MainMessageHub instance */
  static get shared() {
    return t || (t = new o()), t;
  }
}
let n;
class c extends a {
  constructor(e) {
    super({ ...e, type: "renderer" }, "RendererMessageHub");
  }
  emit(e, ...s) {
    return super._emit(this._ipc, e, ...s);
  }
  on(e, s) {
    this._on(this._ipc, e, s);
  }
  off(e) {
    this._off(this._ipc, e);
  }
  /** shared MainMessageHub instance */
  static get shared() {
    return n || (n = new c()), n;
  }
}
export {
  o as MainMessageHub,
  c as RendererMessageHub,
  l as setConfig
};
